// C Source File
// Created 06/04/02; 10:01:37

// #define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "english.h"
short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File




typedef struct list
{
	struct list *next;
	char *name;
	unsigned int size;//taille du fichier

}List;






unsigned long size_list(List *liste)
{
	unsigned long size=0;
	while(liste)
	{
		size+=liste->size;
		liste=liste->next;
	}
	return size;
	
}
int length_list(List *liste)
{
	int size=0;
	while(liste)
	{
		size++;
		liste=liste->next;
	}
	return size;
}


int packin(List *liste,char *name)
{  char buffer[20];
 	SYM_ENTRY *SymPtr=NULL;
 	char *corpsnew=NULL,*corpsfile=NULL,*courant=NULL;
 	List *debut=NULL;
 	int i=0;
	//name:name of the file packed
	//create nam of the file packed:
	debut=liste;
	
	
	
	
	buffer[0]=0;
	strcpy(buffer+1,name);
	//done
	//add a symbol file packed in the vat
	SymPtr=DerefSym (SymAdd(buffer+strlen(buffer+1)+1));
	if(!SymPtr)
	return 0;
	//done
		
	//allocate the block 
	corpsnew = (char*)HeapDeref (SymPtr->handle = HeapAlloc(size_list(liste)+11+20*length_list(liste)+50));
	if(!corpsnew)
	return 0;
	//done
	corpsnew[2]=0;
	corpsnew[3]=1;
	corpsnew[4]=length_list(liste);
	courant=&corpsnew[5+20*corpsnew[4]];
	
	//on defile toute la liste pour inscrire les donnes!
	
	while(liste)
	{
		buffer[0]=0;
		strcpy(buffer+1,liste->name);
		//on ouvre les fichier concern
		SymPtr=DerefSym (SymFind(buffer+strlen(buffer+1)+1));
		if(!SymPtr)
		return 0;
		
		corpsfile = (char*)HeapDeref (SymPtr->handle);
		if(!corpsfile)
		return 0;
		
		//on copie le nom!
		memcpy(&corpsnew[5+i*20],liste->name,20);
		memcpy(courant,corpsfile,*(unsigned int *)corpsfile+2);
		courant+=*(unsigned int *)corpsfile+2;
		
		
		
		
		
		
		i++;
		liste=liste->next;
		
	}
	
	*(int *)corpsnew=size_list(debut)+3+20*corpsnew[4]+6;
	*courant=0;
	courant++;
	*courant='P';
	courant++;
	*courant='K';
	courant++;
	*courant='D';
	courant++;
	*courant=0;
	courant++;
	*courant=248;
	//on definit la taille total du fichier!
	
	return 1;
}


int unpack(char *nomarchive)
{
	char nomar[20];//creation du nom du nom du fichier!
	char buffer[20],phrase[50];
	SYM_ENTRY *sfichier=NULL,*snew=NULL;
	HSym hnew;
	unsigned char nombre_fichier=0;
	int i=0;//compteur
	char *corps=NULL,*corpsnew=NULL,*courant=NULL;
	unsigned int taille=0;
	WINDOW w;
	WinOpen (&w, MakeWinRect (30, 35, 130, 75), WF_SAVE_SCR | WF_TTY|WF_ROUNDEDBORDER|WF_TITLE,"Unpack");
  WinActivate (&w);
  WinFont (&w, F_4x6);
	//clrscr();
	//on ouvre le fichier!
	nomar[0]=0;
	strcpy(&nomar[1],nomarchive);
	hnew = SymFind(nomar+strlen(nomarchive)+1);
	if(hnew.folder==0)
	{
		  	WinClose (&w);
		  	return 0;
	}

	//le fichier existe et on le dereference
	snew=DerefSym(hnew);
	corps= (char*)HeapDeref (snew->handle);
	
	nombre_fichier=corps[4];
	courant=corps+5+(nombre_fichier)*20;
	

	for(i=0;i<nombre_fichier;i++)
	{
	buffer[0]=0;
	memcpy(buffer+1,corps+5+i*20,19);
	
	//printf("create %s\n",buffer+1);	
	//seule facon car *(int *)courant plante ????
	memcpy(&taille,courant,2);
	taille+=2;
	if( DerefSym (SymFind(buffer+strlen(buffer+1)+1)))	
	{
		sprintf(phrase,"File %s exist already!",buffer+1);
	DlgMessage (signal_erreur,phrase, BT_OK, BT_NO);
	goto boucle;
	} 
	sfichier = DerefSym (SymAdd (buffer+strlen(buffer+1)+1));//on ouvre un nouveau fichier
	corpsnew = (char*)HeapDeref (sfichier->handle = HeapAlloc(taille+10));
	memcpy((void *)corpsnew,(void *)courant,taille);
	//printf("archive %s\n",buffer+1);
	WinClr (&w); 
	sprintf(phrase,"%s create!",buffer+1);
	WinStrXY (&w, 8,8,phrase);
	WinStrXY (&w, 8,15,"archive:en cours...");
	if(!EM_moveSymToExtMem (buffer+strlen(buffer+1)+1, HS_NULL))
	{
			DlgMessage (signal_erreur,arch, BT_OK, BT_NO);
	}

	
	boucle:
		courant+=taille;
	}

	
	
	WinClose (&w);
	return 1;
}

int ajout_liste(List **liste,char *name)
{
	char buffer[20],phrase[50];
	SYM_ENTRY *SymPtr=NULL;
	unsigned char *corps=NULL;
	unsigned int length;
	List *tmp,*tmp2;
	buffer[0]=0;
	strcpy(buffer+1,name);
	SymPtr=DerefSym (SymFind(buffer+strlen(buffer+1)+1));
	if(!SymPtr)
	{
	sprintf(phrase,"%s does not exist!",name);
	DlgMessage (signal_erreur,phrase, BT_OK, BT_NO);
	return-1;
	}
	
	corps=(unsigned char*)HeapDeref (SymPtr->handle);
	length=*(unsigned int *)corps;
	
	if(!(tmp=(List *)malloc(sizeof(List))))
	{
			DlgMessage (signal_erreur,no_memory, BT_OK, BT_NO);
			return -1;
	}

	tmp->next=NULL;
	tmp->name=(char *)malloc(20);
	strcpy(tmp->name,name);
	tmp->size=length+2;
	
	tmp2=*liste;
	*liste=tmp;
	tmp->next=tmp2;
	
	return 1;
}

int listing(char *data,unsigned int length,List **liste)//pointeur sur la donne du fichier txt
{
	char *data2=NULL;
	char command[20];
	int i=0;
	data2=data+14;
	debut:
	while(*data2!=13)
	{
	
	  if(i==19)
	  break;
		command[i]=*data2;
		
		i++;
		data2++;
		if(data2>(data+length))
		return 1;
		
	}

	data2+=2;//pour virer l'espace
	command[i]='\0';
	i=0;
  ajout_liste(liste,command);
  
	
	goto debut;
	
	
}



unsigned long evaluation(List *liste)
{

	unsigned long valeur;
	valeur=(unsigned long)size_list(liste)+11+20*(unsigned long)length_list(liste);
	
return valeur;
}








int is_packed(char *name)
{
	char buffer[20];
	char output[20];
	char buffer2[50];
	SYM_ENTRY *SymPtr=NULL;
	unsigned char *corps=NULL;
	unsigned int lenght;
	unsigned long eva;//:)
	List *liste=NULL;
	HANDLE handle = DialogNewSimple (140, 55);
	DialogAddTitle (handle, "Name file create?", BT_OK, BT_CANCEL);
	DialogAddRequest (handle, 3, 30, "output->", 0, 20, 14);
 	
 	
	
	
	buffer[0]=0;
	strcpy(buffer+1,name);
	SymPtr=DerefSym (SymFind(buffer+strlen(buffer+1)+1));
	if(!SymPtr)
		return -1;
	
	corps=(unsigned char*)HeapDeref (SymPtr->handle);
	lenght=*(unsigned int *)corps;
	if(!strncmp (&corps[lenght-3], "PKD", 3)&&corps[lenght+1]==248)
	{
	
			return 1;//unpacked
	}

	if(!strncmp (&corps[5], "packed:", 7)&&corps[lenght+1]==224)
	{
	output[0]=0;
	listing(corps,lenght,&liste);//listing de la liste
	eva=evaluation(liste);
	if(eva>64000)
	{
		DlgMessage (signal_erreur,big_file, BT_OK, BT_NO);
		return 4;
	}
	sprintf(buffer2,"size file:%ld",eva);

	if(DlgMessage ("Info",buffer2, BT_OK, BT_NO)==KEY_ESC)
	return 4;
	
	DialogDo (handle, CENTER, CENTER,output, NULL);//nom de sortie
	if(*output==('\0'))
	return 4;
	
	packin(liste,output);//creation du bloc
	
			
	 return 0;//packed
	}
	
	
	
	return 3;//format non reconnu!
}



// Main Function
void _main(void)
{

ESI argptr;
int argtype;
char *command=NULL;
char erreur=0,resultat=-1;
List *liste=NULL;
InitArgPtr (argptr);
argtype = GetArgType(argptr);
if (argtype == STR_TAG)
{
command=GetStrnArg (argptr);
if(*command=='\0')
{
	erreur=1;
	goto exit;
}
//on regarde si le fichier existe
resultat=is_packed(command);
	switch(resultat)
	{
		case -1:DlgMessage (signal_erreur,no_file, BT_OK, BT_NO);
		break;
		case 1:
		unpack(command);
		break;
		
		case 3:DlgMessage (signal_erreur,bad_format, BT_OK, BT_NO);
		break;
	}
	




}


exit:
if(erreur)
DlgMessage (signal_erreur,bad_arg, BT_OK, BT_NO);


}








